﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxCall
    {
                
        public cVaxCall()
        {
        }

        ~cVaxCall()
        {
        }

        public bool AcceptCallSession(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName)
        {
            bool bResult = cVaxServerExCOM.m_objVaxServerExCOM.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName);

            if(!bResult)
            {
                cVaxServerExCOM.m_objVaxServerExCOM.RejectCallSession(nSessionId, 404, "Not Found");
                return false;
            }

            return true;
        }
        
        public void OnIncomingCall(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nFromPeerType, string sFromPeerName, int nToPeerType, string sToPeerName, ref bool bProcessed)
        {
            bProcessed = false;

            if(nToPeerType == cVaxServerCOM.VAX_PEER_TYPE_LINE)
            {
                sCallerName = "";
                sCallerId = "";
                // Let AcceptCallSession() use DisplayName & UserName values of LINE as CallerName & CallerId. Required by the ITSP (IP-Telephony service provider).
            }

            if(sDialNo.Length == 0 || sToPeerName.Length == 0)
               return;
            
            if(!AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName))
               return;

           bProcessed = true;
        
        }
                
        public void OnCallSessionCreated(int nSessionId, int nReasonCode)
        {
        }

        public void OnCallSessionConnecting(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            cVaxServerExCOM.m_objVaxServerExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, "");
        }

        public void OnCallSessionFailed(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            cVaxServerExCOM.m_objVaxServerExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, "");
        }

        public void OnCallSessionConnected(int nSessionId)
        {
        }

        public void OnCallSessionClosed(int nSessionId, int nChannelId, int nReasonCode)
        {
        }

        public void OnCallSessionLost(int nSessionId, int nChannelId)
        {
        }

        public void OnCallSessionHangup(int nSessionId, int nChannelId)
        {
        }

        public void OnCallSessionTimeout(int nSessionId, int nChannelId)
        {
        }

        public void OnCallSessionCancelled(int nSessionId)
        {
        }

        public void OnCallSessionOpenCall(int nSessionId, int nChannelId, int nPeerType, string sPeerName)
        { 
        }

        public void OnCallSessionCloseCall(int nSessionId, int nChannelId, int nPeerType, string sPeerName)
        { 
        }
     }
}
