﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cConfRoomDetails
    {

	    public cConfRoomDetails(){}
	    ~cConfRoomDetails(){}

	    public string m_sRoomName = "", m_sRoomNo = "";
    }

    class cConfRoomList
    {

        Hashtable m_objMapConfRoomByName;
        Hashtable m_objMapConfRoomByNo;

        public cConfRoomList()
        {
            m_objMapConfRoomByName = new Hashtable(256);
            m_objMapConfRoomByNo = new Hashtable(256);
        }

        ~cConfRoomList()
        {
            DeleteRoomAll();
        }

	    private string GenKey(string sValue)
        {
            return sValue.ToLower();
        }

	    private cConfRoomDetails FindRoomByName(string sRoomName)
        {
            return (cConfRoomDetails)m_objMapConfRoomByName[sRoomName.ToLower()];
        }

	    private cConfRoomDetails FindRoomByNo(string sRoomNo)
        {
            return (cConfRoomDetails)m_objMapConfRoomByNo[sRoomNo.ToLower()];
        }

	    public void DeleteRoomAll()
        {
            m_objMapConfRoomByName.Clear();
            m_objMapConfRoomByNo.Clear();
        }

        public bool AddRoom(string sRoomName, string sRoomNo)
        {
            cConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if(pConfRoom != null) return false;

            pConfRoom = FindRoomByNo(sRoomNo);
            if(pConfRoom != null) return false;

            pConfRoom = new cConfRoomDetails();

            pConfRoom.m_sRoomName = sRoomName;
            pConfRoom.m_sRoomNo = sRoomNo;

            // Save by RoomName

            string sKey = GenKey(sRoomName);
            m_objMapConfRoomByName.Add(sKey, pConfRoom);

            // Save by RoomNo

            sKey = GenKey(sRoomNo);
            m_objMapConfRoomByNo.Add(sKey, pConfRoom);

            return true;
        }
	    
        public void RemoveRoom(string sRoomName)
        {
            cConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if(pConfRoom == null) return;

            string sKey = GenKey(pConfRoom.m_sRoomNo);
            m_objMapConfRoomByNo.Remove(sKey);

            sKey = GenKey(sRoomName);
            m_objMapConfRoomByName.Remove(sKey);

            pConfRoom = null;
        }

	    public string GetRoomName(string sRoomNo)
        {
            cConfRoomDetails pConfRoom = FindRoomByNo(sRoomNo);
            if(pConfRoom == null) return "";

            return pConfRoom.m_sRoomName;
        }

	    public bool GetRoomDetails(string sRoomName, ref string sRoomNo)
        {
            cConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if(pConfRoom == null) return false;

            sRoomNo = pConfRoom.m_sRoomNo;

            return true;
        }
	    
        public bool IsRoomNoExists(string sRoomNo)
        {
            cConfRoomDetails pConfRoom = FindRoomByNo(sRoomNo);
            if(pConfRoom == null) return false;

            return true;
        }

	    public bool GetRoomAll(ref ArrayList pRoomList)
        {
            foreach (object objValue in m_objMapConfRoomByName.Values)
            {
                cConfRoomDetails objRoom = (cConfRoomDetails)objValue;
                pRoomList.Add(objRoom.m_sRoomName);
            }

            return true;
        }
    }
}
