

Imports ServerSIP.VBNetSIPServerSample

Public Class LoginForm

    Private m_objVaxTeleSIP As cVaxServerSIP

    Public Class ComboBoxRouteItem

        Public Property m_sToPeerName As String
        Public Property m_nToPeerType As Object

        Public Overrides Function ToString() As String
            Return m_sToPeerName
        End Function

    End Class

    Dim m_arrComboBoxRouteItem As ArrayList

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP
        m_arrComboBoxRouteItem = New ArrayList()

    End Sub

    Private Sub BtnAddLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLogin.Click

        If AddLoginChecks() = False Then
            Exit Sub
        End If

        If ComboLogin.FindStringExact(ComboLogin.Text) <> -1 Then
            If (MessageBox.Show("Login already exist, do you want to continue?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = DialogResult.No) Then
                Return
            End If
        End If

        Dim objCodec As New cCodec
        Dim sCodec As String = ""

        Dim nCount As Integer

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount))
        Next

        '///////////////////////////////////////////////////////////////////////

        Dim nToPeerType As Integer = -1
        Dim sToPeerName As String = ""

        Dim nSelectedIndex As Integer = ComboLoginRoute.SelectedIndex

        If nSelectedIndex <> -1 Then
            Dim comboLineItem As ComboBoxRouteItem = m_arrComboBoxRouteItem(nSelectedIndex)
            nToPeerType = comboLineItem.m_nToPeerType
            sToPeerName = comboLineItem.m_sToPeerName
        End If

        '///////////////////////////////////////////////////////////////////////

        If (ComboLogin.Items.Contains(ComboLogin.Text)) Then
            m_objVaxTeleSIP.RemoveUser(ComboLogin.Text)
        End If

        If (m_objVaxTeleSIP.AddUser(ComboLogin.Text, EditPassword.Text, sCodec, CheckBoxBlockAccount.Checked, EditCallPrefix.Text, EditDialPrefix.Text, nToPeerType, sToPeerName) = False) Then
            MessageBox.Show("Login could not be created or Please start the server first.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (Not ComboLogin.Items.Contains(ComboLogin.Text)) Then
            ComboLogin.Items.Add(ComboLogin.Text)
        End If

        MessageBox.Show("Login created successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnRemoveLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLogin.Click

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nIndex As Integer = ComboLogin.FindStringExact(ComboLogin.Text)

        If nIndex = -1 Then
            Exit Sub
        End If

        m_objVaxTeleSIP.RemoveUser(ComboLogin.Text)
        ComboLogin.Items.RemoveAt(nIndex)

        ClearDlgContent()

        If (ComboLogin.Items.Count > 0) Then
            ComboLogin.SelectedIndex = 0
        End If

        ShowUserDetails()

        MessageBox.Show("Login removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click

        If ListBoxEnableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString)
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)

    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click

        If ListBoxDisableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString)
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)

    End Sub

    Private Sub ComboLogin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboLogin.SelectedIndexChanged
        ShowUserDetails()
    End Sub

    Private Sub ClearDlgContent()

        ComboLogin.Text = ""

        EditPassword.Text = ""
        EditCallPrefix.Text = ""
        EditDialPrefix.Text = ""

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        CheckBoxBlockAccount.Checked = False

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

    Private Sub BtnClearLoginDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLoginDlg.Click
        ClearDlgContent()
    End Sub

    Private Sub AddLoginForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadCodecs()

    End Sub

    Public Sub LoadCodecs()

        Dim objCodec As cCodec = New cCodec()
        Dim nCount = 0

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC - 1
            ListBoxEnableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

    End Sub

    Public Sub AddUsers()

        ComboLogin.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetUserNameAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            ComboLogin.Items.Add(objUserList.Item(nIndex))
        Next

        If (ComboLogin.SelectedIndex = -1) Then
            If (ComboLogin.Items.Count > 0) Then
                ComboLogin.SelectedIndex = 0
            End If
        End If

        If (ComboLogin.Items.Count > 0) Then
            ComboLogin.SelectedIndex = 0
        End If

    End Sub

    Public Sub AddLines()

        Dim objListLines As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetLineAll(objListLines)

        If (objListLines.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objListLines.Count - 1

            Dim m_sToPeerName As String = objListLines(nIndex).ToString()
            ComboLoginRoute.Items.Add(m_sToPeerName)

            Dim comboRouteItem As ComboBoxRouteItem = New ComboBoxRouteItem()
            comboRouteItem.m_sToPeerName = objListLines(nIndex).ToString()
            comboRouteItem.m_nToPeerType = cVaxServerCOM.VAX_PEER_TYPE_LINE

            m_arrComboBoxRouteItem.Add(comboRouteItem)
        Next

        If (ComboLoginRoute.Items.Count > 0) Then
            ComboLoginRoute.SelectedIndex = 0
        End If

    End Sub

    Public Sub AddDirectProxies()

        Dim objProxyList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetDirectProxyAll(objProxyList)

        If (objProxyList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objProxyList.Count - 1

            Dim m_sToPeerName As String = objProxyList(nIndex).ToString()
            ComboLoginRoute.Items.Add(m_sToPeerName)

            Dim comboRouteItem As ComboBoxRouteItem = New ComboBoxRouteItem()
            comboRouteItem.m_sToPeerName = objProxyList(nIndex).ToString()
            comboRouteItem.m_nToPeerType = cVaxServerCOM.VAX_PEER_TYPE_DIRECT_PROXY

            m_arrComboBoxRouteItem.Add(comboRouteItem)
        Next

        If (ComboLoginRoute.Items.Count > 0) Then
            ComboLoginRoute.SelectedIndex = 0
        End If

    End Sub

    Public Sub OnSetActive()

        ComboLoginRoute.Items.Clear()

        AddLines()
        AddDirectProxies()
        AddUsers()

        ShowUserDetails()

    End Sub

    Public Sub ShowUserDetails()

        Dim sLogin As String = ComboLogin.Text
        If (sLogin.Length = 0) Then Return

        Dim sPassword As String = "", sCodecList As String = ""
        Dim sDialPrefix As String = "", sCallPrefix As String = "", sToPeerName As String = ""
        Dim bBlocked = False
        Dim nToPeerType = -1

        Dim bResult As Boolean = m_objVaxTeleSIP.GetUserDetails(sLogin, sPassword, sCodecList, bBlocked, sCallPrefix, sDialPrefix, nToPeerType, sToPeerName)

        If (bResult = False) Then
            Return
        End If

        UpdateDlgContent(sLogin, sPassword, sCodecList, sDialPrefix, sCallPrefix, sToPeerName, bBlocked)

    End Sub

    Private Sub UpdateDlgContent(ByVal sLogin As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal sDialPrefix As String, ByVal sCallPrefix As String, ByVal sConnectName As String, ByVal bBlock As Boolean)

        If sLogin.Length = 0 Then
            Return
        End If

        EditPassword.Text = sPassword
        EditDialPrefix.Text = sDialPrefix
        EditCallPrefix.Text = sCallPrefix

        CheckBoxBlockAccount.Checked = bBlock

        ComboLoginRoute.SelectedIndex = ComboLoginRoute.FindStringExact(sConnectName)

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim nCount As Integer
        Dim objCodec As New cCodec

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String

        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount))
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

    End Sub

    Function AddLoginChecks() As Boolean

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Dim nCount As Integer
        Dim sDigit As String = "0123456789"

        For nCount = 0 To ComboLogin.Text.Length - 1
            If sDigit.IndexOf(ComboLogin.Text.Chars(nCount)) = -1 Then
                MessageBox.Show("Login should contain only numerals 0 through 9. For example: 12, 324323, 800122, 2109756 etc.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return False
            End If
        Next

        If EditPassword.Text.Length = 0 Then
            MessageBox.Show("Please enter login password.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ComboLogin.Text.Length > 20 Or EditPassword.Text.Length > 20 Then
            MessageBox.Show("Login and password size should not be more 20.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ComboLogin.Text.Substring(0, 2) = "00" Then
            MessageBox.Show("Please donot enter 00 as login prefix. 00 prefix is use to prepare dial plan.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ListBoxEnableCodec.Items.Count = 0 Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return True

    End Function

End Class