#pragma once

//------------------------------------------------------------------------------------------------------------------
//-------------------------------			class CUserRouteDetails
//------------------------------------------------------------------------------------------------------------------

class CUserRouteDetails
{

public:

	CString m_sUserPrefix, m_sToPeerName, m_sDialPrefix;
	int m_nToPeerType;

public:

	CUserRouteDetails(){};
	~CUserRouteDetails(){};
};

//------------------------------------------------------------------------------------------------------------------
//-------------------------------			class CLineRouteDetails
//------------------------------------------------------------------------------------------------------------------

class CLineRouteDetails
{

public:

	CString m_sLineName; 
	CString m_sRoomName;

	int m_nToPeerType;
	CString m_sToPeerName;
	
	BOOL m_bRejected;
	
public:

	CLineRouteDetails(){};
	~CLineRouteDetails(){};
};

//------------------------------------------------------------------------------------------------------------------
//-------------------------------			Class CDirectProxyRouteDetails
//------------------------------------------------------------------------------------------------------------------

class CDirectProxyRouteDetails
{

public:

	CString m_sProxyName; 
	CString m_sRoomName;

	int m_nToPeerType;
	CString m_sToPeerName;
	
	BOOL m_bRejected;
	
public:

	CDirectProxyRouteDetails(){};
	~CDirectProxyRouteDetails(){};
};


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

class CVaxServerExCOM;

class CVaxCallSessionRoute
{
	 
public:

	CVaxCallSessionRoute(CVaxServerExCOM* pServerExCOM);
	~CVaxCallSessionRoute();

private:

	LONG m_lUserRouteList;
	LONG m_lLineRouteList;
	LONG m_lProxyRouteList;

	CVaxServerExCOM* m_pServerExCOM;

private:

	CString GenKey(LPCTSTR sValue);

	CUserRouteDetails* FindUserRoute(LPCTSTR sUserName);
	CLineRouteDetails* FindLineRoute(LPCTSTR sLineName);
	CDirectProxyRouteDetails* FindDirectProxyRoute(LPCTSTR sProxyName);

	void DeleteAllUserRoutes();
	void DeleteAllLineRoutes();
	void DeleteAllProxyRoutes();

	BOOL GetUserRouteDetails(LPCTSTR sUserName, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName);
	BOOL GetLineRouteDetails(LPCTSTR sLineName, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);
	BOOL GetDirectProxyRouteDetails(LPCTSTR sProxyName, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);

public:

	BOOL OnCallFromUser(LPCTSTR sUserName, LPCTSTR sUserDialedNo, CString& sDialNo, int& nToPeerType, CString& sToPeerName);
	BOOL OnCallFromLine(LPCTSTR sLineName, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);
	BOOL OnCallFromDirectProxySIP(LPCTSTR sProxyName, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);

public:

	BOOL AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUserRoute(LPCTSTR sUserName);

	BOOL AddLineRoute(LPCTSTR sLineName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveLineRoute(LPCTSTR sLineName);

	BOOL AddDirectProxyRoute(LPCTSTR sProxyName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveDirectProxyRoute(LPCTSTR sProxyName);
	
	void ResetOBJ();
};

