#pragma once

#include "VaxServerCOM.h"

class CConfRoom;
class CVaxChat;
class CVaxCallSessionRoute;

class CVaxServerExCOM :	public CVaxServerCOM
{

public:
	
	CVaxServerExCOM();
	~CVaxServerExCOM();

private:

	CConfRoom* m_pConfRoom;
	CVaxChat* m_pChat;
	
	CVaxCallSessionRoute* m_pRouteCallSIP;

	LONG m_lDialToneId;
	BOOL m_bInitilized;

	UINT m_nTotalCallCount;
	UINT m_nRegisterUserCount;

public:

	CString m_sLicenseKey;

public:

	void SetLicenseKey(LPCTSTR sLicenseKey);
	
	BOOL Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort);
	void UnInitialize();

	 BOOL IsInitialized();

	BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUser(LPCTSTR sUserName);
	
	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName);
	void RemoveLine(LPCTSTR sLineName);
		
	
	BOOL AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlocked, LPCTSTR sRoomName);
	void RemoveDirectProxySIP(LPCTSTR sProxyName);


	LONG GetVaxErrorCode();

	BOOL DialToneToCallSession(BOOL bEnable, LONG lSessionId);
	BOOL DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound);
		
public:

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	BOOL IsRoomNoExist(LPCTSTR sRoomNo);
	
	BOOL IsUserExist(LPCTSTR sUserName);
	BOOL IsLineExist(LPCTSTR sLineName);
	BOOL IsDirectProxyExist(LPCTSTR sProxyName);

public:

	BOOL AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUserRoute(LPCTSTR sUserName);

	BOOL AddLineRoute(LPCTSTR sLineName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveLineRoute(LPCTSTR sLineName);

	BOOL AddDirectProxyRoute(LPCTSTR sProxyName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveDirectProxyRoute(LPCTSTR sProxyName);

public:

	BOOL LoadMusicDialTone(LPCTSTR sFileName);
	void UnLoadMusicDialTone();

	LONG GetCallCount();
	
private:

	void DeleteCallSessionDataAll();
	void DeleteUserDataAll();
	void DeleteLineDataAll();

public:
	
	UINT GetRegisteredUserCount();

public:

	void GenStatusLog(LPCTSTR sStatus);
					
public:

	void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnUnRegisterUser(LPCTSTR sUserLogin);
		
	void OnCallSessionConnecting(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnCallSessionFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	
	void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort);
	
	void OnCallSessionCreated(LONG nSessionId, LONG nReasonCode);
	void OnCallSessionClosed(LONG nSessionId, LONG nChannelId, LONG nReasonCode);
	
	void OnCallSessionOnHold(LONG nSessionId, LONG nChannelId);
	void OnCallSessionOffHold(LONG nSessionId, LONG nChannelId);

	void OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfereeSessionId, LONG nTransferToSessionId, LONG nTransfererChannelId, LONG nTransfereeChannelId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);

	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);
	
	void OnChatMessageText(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	void OnChatMessageTyping(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL IsTypingStart, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	
	void OnChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);

	void OnChatMessageSuccess(LONG nChatMsgId);
	void OnChatMessageFailed(LONG nChatMsgId, LONG nStatusId, LPCTSTR sReasonPhrase);
	void OnChatMessageTimeout(LONG nChatMsgId);

	void OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF);
	
	void OnCallSessionRecordedPCM(LONG nSessionId, LONG nChannelId, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM);
	void OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM);

	void OnBusyLampSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	void OnBusyLampUnSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	void OnBusyLampSubscribeSuccess(LONG nSubScrbId, LPCTSTR sUserName);
	void OnBusyLampSubscribeFailed(LONG nSubScrbId, LPCTSTR sUserName);
	void OnBusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId);

	void OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg);
	
protected:

	virtual void OnInitialize();
	virtual void OnStatusLog(LPCTSTR sMsg);
	virtual void OnErrorLog(LPCTSTR sMsg);

};


