#include "StdAfx.h"
#include "Define.h"
#include "VaxUser.h"
#include "VaxServerExCOM.h"

CVaxUser::CVaxUser(CVaxServerExCOM* pServerExCOM)
{
	m_pServerExCOM = pServerExCOM;
	m_bBlocked = FALSE;

	m_bRegistered = FALSE;
}

CVaxUser::~CVaxUser()
{
	
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxUser::OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG lFromPort, LONG lRegId)
{
	if(m_bBlocked)
	{
		m_pServerExCOM->RejectRegister(lRegId, 404, "Not Found");
		return;
	}
	
	BOOL bResult = m_pServerExCOM->AuthRegister(lRegId);

	CString sStatus;
	sStatus.Format("%s %s", sUserLogin, USER_REG_TRYING);

	 m_pServerExCOM->GenStatusLog(sStatus);
}

void CVaxUser::OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG lFromPort, LONG lRegId)
{
	m_bRegistered = TRUE;
	
	CString sStatus;
	sStatus.Format("%s %s", sUserLogin, USER_REG_SUCCESS);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}

void CVaxUser::OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG lFromPort, LONG lRegId)
{
	CString sStatus;
	sStatus.Format("%s %s", sUserLogin, USER_REG_FAILED);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}

void CVaxUser::OnUnRegisterUser(LPCTSTR sUserLogin)
{
	m_bRegistered = FALSE;
	
	CString sStatus;
	sStatus.Format("%s %s", sUserLogin, USER_UNREGISTER);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxUser::SetData(LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName)
{
	m_sPassword   = sPassword;
	m_sCodecList  = sCodecList;

	m_bBlocked    = bBlocked;
	
	m_sUserPrefix = sUserPrefix;
	m_sDialPrefix = sDialPrefix;

	m_nToPeerType = nToPeerType;
	m_sToPeerName = sToPeerName;
}

void CVaxUser::GetData(CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName)
{
	sPassword   = m_sPassword;
	sCodecList  = m_sCodecList;

	bBlocked    = m_bBlocked;
	
	sUserPrefix = m_sUserPrefix;
	sDialPrefix = m_sDialPrefix;

	nToPeerType = m_nToPeerType;
	sToPeerName = m_sToPeerName;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL CVaxUser::IsRegistered()
{
	return m_bRegistered;
}