﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreLine : cStoreRegistry
    {
        const string LINE_ROOT_PATH = "Lines\\";

        public cStoreLine()
        {
        }
        
        ~cStoreLine()
        {
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        public bool AddLine(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sDomainRealm, string sProxySIP, string sOutboundProxySIP, string sCodecList, bool bRegister)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;

            base.SetTEXT(sKeyPath, "LineName", sLineName);
            base.SetTEXT(sKeyPath, "DisplayName", sDisplayName);
            base.SetTEXT(sKeyPath, "UserName", sUserName);
            base.SetTEXT(sKeyPath, "AuthUser", sAuthUser);

            base.SetTEXT(sKeyPath, "AuthPwd", sAuthPwd);
            base.SetTEXT(sKeyPath, "DomainRealm", sDomainRealm);
            base.SetTEXT(sKeyPath, "ProxySIP", sProxySIP);

            base.SetTEXT(sKeyPath, "OutboundProxySIP", sOutboundProxySIP);
            base.SetTEXT(sKeyPath, "CodecList", sCodecList);

            base.SetBOOL(sKeyPath, "Register", bRegister);
            return true;
        }

        public void RemoveLine(string sLineName)
        {
            if (sLineName.Length == 0)
                return;

            string sKeyPath = LINE_ROOT_PATH + sLineName;
            base.DeleteSubKey(sKeyPath);
        }

      //////////////////////////////////////////////////////////////////////////////////

        public bool GetLine(string sLineName, ref string sDisplayName, ref string sUserName, ref string sAuthUser, ref string sAuthPwd, ref string sDomainRealm, ref string sProxySIP, ref string sOutboundProxySIP, ref string sCodecList, ref bool bRegister)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;

            base.GetTEXT(sKeyPath, "LineName", ref sLineName);
            base.GetTEXT(sKeyPath, "DisplayName", ref sDisplayName);
            base.GetTEXT(sKeyPath, "UserName", ref sUserName);

            base.GetTEXT(sKeyPath, "AuthUser", ref sAuthUser);
            base.GetTEXT(sKeyPath, "AuthPwd", ref sAuthPwd);
            base.GetTEXT(sKeyPath, "DomainRealm", ref sDomainRealm);

            base.GetTEXT(sKeyPath, "ProxySIP", ref sProxySIP);
            base.GetTEXT(sKeyPath, "OutboundProxySIP", ref sOutboundProxySIP);
            base.GetTEXT(sKeyPath, "CodecList", ref sCodecList);

            base.GetBOOL(sKeyPath, "Register", ref bRegister);
            return true;
        }

        public Boolean GetLineNameAll(ref List<string> objListLineName)
        {
            objListLineName.Clear();

            string sKeyPath = LINE_ROOT_PATH;
            return base.EnumSubKeys(sKeyPath, ref objListLineName);
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool AddLineRoute(string sLineName, int nToPeerType, string sToPeerName, bool bRejected, string sRoomName)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;

            base.SetINT(sKeyPath, "ToPeerType", nToPeerType);
            base.SetBOOL(sKeyPath, "Rejected", bRejected);

            base.SetTEXT(sKeyPath, "ToPeerName", sToPeerName);
            base.SetTEXT(sKeyPath, "RoomName", sRoomName);

            return true;
        }

        public bool GetLineRoute(string sLineName, ref int nToPeerType, ref string sToPeerName, ref bool bRejected, ref string sRoomName)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;

            base.GetINT(sKeyPath, "ToPeerType", ref  nToPeerType);
            base.GetBOOL(sKeyPath, "Rejected", ref bRejected);

            base.GetTEXT(sKeyPath, "ToPeerName", ref sToPeerName);
            base.GetTEXT(sKeyPath, "RoomName", ref sRoomName);

            return true;
        }

        public bool RemoveLineRoute(string sLineName)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;

            base.DeleteValue(sKeyPath, "ToPeerType");
            base.DeleteValue(sKeyPath, "Rejected");

            base.DeleteValue(sKeyPath, "ToPeerName");
            base.DeleteValue(sKeyPath, "RoomName");
                        
            return true;
        }
    }
}
